Server : nginx/1.20.1 System : Linux ccpf-production-2021 5.4.0-148-generic #165-Ubuntu SMP Tue Apr 18 08:53:12 UTC 2023 x86_64 User : forge ( 1000) PHP Version : 7.4.21 Disable Function : pcntl_alarm,pcntl_fork,pcntl_waitpid,pcntl_wait,pcntl_wifexited,pcntl_wifstopped,pcntl_wifsignaled,pcntl_wifcontinued,pcntl_wexitstatus,pcntl_wtermsig,pcntl_wstopsig,pcntl_signal,pcntl_signal_get_handler,pcntl_signal_dispatch,pcntl_get_last_error,pcntl_strerror,pcntl_sigprocmask,pcntl_sigwaitinfo,pcntl_sigtimedwait,pcntl_exec,pcntl_getpriority,pcntl_setpriority,pcntl_async_signals,pcntl_unshare, Directory : /usr/lib/node_modules/npm/node_modules/libnpx/ |
'use strict'
const Y = require('./y.js')
function mkPosix (opts) {
return `
command_not_found_${opts.isBash ? 'handle' : 'handler'}() {
# Do not run within a pipe
if test ! -t 1; then
>&2 echo "${Y`command not found: ${'$1'}`}"
return 127
fi
if which npx > /dev/null; then
echo "${Y`${'$1'} not found. Trying with npx...`}" >&2
else
return 127
fi
if ! [[ $1 =~ @ ]]; then
npx --no-install "$@"
else
npx "$@"
fi
return $?
}`
}
function mkFish (opts) {
return `
function __fish_command_not_found_on_interactive --on-event fish_prompt
functions --erase __fish_command_not_found_handler
functions --erase __fish_command_not_found_setup
function __fish_command_not_found_handler --on-event fish_command_not_found
if which npx > /dev/null
echo "${Y`${'$argv[1]'} not found. Trying with npx...`}" >&2
else
return 127
end
if string match -q -r @ $argv[1]
npx $argv
else
npx --no-install $argv
end
end
functions --erase __fish_command_not_found_on_interactive
end`
}
module.exports = autoFallback
function autoFallback (shell, fromEnv, opts) {
if (shell.includes('bash')) {
return mkPosix({isBash: true, install: opts.install})
}
if (shell.includes('zsh')) {
return mkPosix({isBash: false, install: opts.install})
}
if (shell.includes('fish')) {
return mkFish(opts)
}
if (fromEnv) {
return autoFallback(fromEnv, null, opts)
}
console.error(Y`Only Bash, Zsh, and Fish shells are supported :(`)
}